﻿using System;
using System.Collections.Generic;
using System.Linq;
using MySystem.Models.Main;
using Library;
using LitJson;
using System.Text.RegularExpressions;
using System.Threading;

namespace MySystem
{
    public class CheckWeChatSignService
    {
        public readonly static CheckWeChatSignService Instance = new CheckWeChatSignService();
        private CheckWeChatSignService()
        { }

        public void Start()
        {
            Thread th = new Thread(StartListen);
            th.IsBackground = true;
            th.Start();
        }

        public void StartListen()
        {
            while (true)
            {
                string content = RedisDbconn.Instance.RPop<string>("WeChatSignQueue");
                if (!string.IsNullOrEmpty(content))
                {
                    QueryMerchantStatus queryMerchantStatus = Newtonsoft.Json.JsonConvert.DeserializeObject<QueryMerchantStatus>(content);
                    string result = StartDo(queryMerchantStatus);
                    if(result == "wait")
                    {
                        Thread.Sleep(10000);
                        RedisDbconn.Instance.AddList("WeChatSignQueue", queryMerchantStatus);
                    }
                }
                else
                {
                    Thread.Sleep(2000);
                }
            }
        }

        public string StartDo(QueryMerchantStatus query)
        {
            try
            {
                var mId = int.Parse(query.MerchantId);
                WebCMSEntities db = new WebCMSEntities();
                var returnInfo = HaoDaHelper.Instance.QueryMerchantStatus(HaoDaHelper.BrhCode,query.MerchantNo);
                JsonData dic = JsonMapper.ToObject(returnInfo);
                if (dic["data"]["code"].ToString() == "4")
                {
                    MerchantAddInfo merchantadd = db.MerchantAddInfo.FirstOrDefault(m => m.Id == mId);
                    if (merchantadd != null)
                    {
                        merchantadd.Status = 1;
                        // merchantadd.AlipayPid = dic["storeNo"].ToString();
                        // merchantadd.AlipayAuthToken = dic["outMchtNo"].ToString();
                        merchantadd.SeoKeyword = dic["storeNo"].ToString();
                        merchantadd.SeoDescription = dic["outMchtNo"].ToString();
                        MerchantInfo merchant = db.MerchantInfo.FirstOrDefault(m => m.Id == mId);
                        if (merchant != null)
                        {
                            merchant.Status = 1;
                        }
                        JsonData Info = JsonMapper.ToObject(HaoDaHelper.Instance.OpenDivideAccounts(merchantadd.AlipayAuthToken, merchantadd.AlipayPid));
                        if (Info["resultCode"].ToString() == "0")
                        {
                            merchantadd.QueryCount = -1;
                            merchantadd.AlipayRemark = Info["errorDesc"].ToString();
                        }
                        db.SaveChanges();
                    }
                    return "wait";
                }
                else if (dic["data"]["code"].ToString() == "3")
                {
                    MerchantAddInfo merchantadd = db.MerchantAddInfo.FirstOrDefault(m => m.Id == mId);
                    if (merchantadd != null)
                    {
                        merchantadd.WeChatRemark = dic["option"].ToString();
                        merchantadd.Status = -1;
                        MerchantInfo merchant = db.MerchantInfo.FirstOrDefault(m => m.Id == mId);
                        if (merchant != null)
                        {
                            merchant.Status = -1;
                        }
                        db.SaveChanges();
                    }
                }
                else
                {
                    return "wait";
                }
            }
            catch (Exception ex)
            {
                function.WriteLog(DateTime.Now.ToString() + ":" + ex.ToString(), "好哒商户进件状态查询异常");
            }
            return "";
        }
    }
}