using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using MySystem;
using MySystem.Models.Main;

namespace MySystem
{
    /// <summary>
    /// 订单申请分账参数赋值
    /// </summary>
    public class OrderDivideAccountsUtil
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="mchtNo">慧掌柜商户号</param>
        /// <param name="orderNo">交易订单号（好哒平台订单号，G开头）</param>
        /// <param name="amount">金额（分）</param>
        /// <returns></returns>
        public static OrderDivideAccounts SetValue(string mchtNo, string orderNo, decimal amount)
        {
            OrderDivideAccounts orderDivideAccounts = new OrderDivideAccounts();
            orderDivideAccounts.applyNo = "";//必须 批次号
            orderDivideAccounts.mchtNo = mchtNo;//必须 慧掌柜商户号
            orderDivideAccounts.orderNo = orderNo;//必须 交易订单号（好哒平台订单号，G开头）
            
            List<DetailItem> imageList = new List<DetailItem>();
            DetailItem imageItem = new DetailItem();
            
            imageItem.acctNo = ""; //账户号，账户类型为商户收款账户时填收款商户号, 账户类型为分账接收方时填分账接收方账户号
            imageItem.acctType = 1; //账户类型（0：商户收款账户（大B），1：分账接收方账户（小B））
            imageItem.amount = amount; //金额（分）
            imageList.Add(imageItem);
            orderDivideAccounts.detail = imageList; //图片

            return orderDivideAccounts;
        }
    }
}